////////////////////////////////////////////////////
//
//  TI-Compiler  v .01
//  Copyright 1995, Samuel Clement
//
///////////////////////////////////////////////////
#define __MAIN__CPP

#include <dos.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>
#include "tilang.h"
#include "parse.h"
#include "lex.h"
#include "comp.h"

const float TicVersion = 0.97;
bool ErrorInFile;
struct programNode *program;
struct programNode *programHead;
char FinalFileName[20];

void main(int argc, char **argv)
{

	ErrorInFile = false;
	ErrorCount = 0;
	program = programHead = NULL;

	printf("\nTI-Compiler Version %.2f", TicVersion);
	printf("\nCopyright (c) 1995 Samuel Clement, All rights reserved\n\n");
	if (argc != 2) {
	  printf("USAGE: TI-Comp <filename>\n");
	  return;
	}
	printf("Source file - %s\n",argv[1]);
	if (!LexicalAnalyzer(argv[1])) return;
	if ((programHead = TiLangParser(program)) == NULL) exit(1);
	if (!CompileTiLang(programHead, "complr.out")) exit(1);
	printf("\nCompleted with %i errors\n",ErrorCount);
	if (ErrorCount != 0) exit(1);
	exit(0);
}

void error(char *errorstr)
{
	printf("Error: %s\n",errorstr);
	ErrorCount++;
}

char *getmem(int size)
{
	char *p;
	p = (char *)malloc(size);
	if (p == NULL) {
		error("Could not allocate memory");
		abort();
	}
	return(p);
}

char *allocateString(char *s)
{
	char *p;
	if (s==NULL) return(NULL);
	p = getmem(strlen(s)+1);
	strcpy(p,s);
	return(p);
}