// TI-Lang Header
// defines the structures used in the compiler
// specific to the ti-85

#ifndef __TILANG__H
#define __TILANG__H

#ifndef __MAIN__CPP
	#define declare extern
#else
	#define declare
#endif

#include <ctype.h>

// utility declarations

#define bool			int
#define true			1
#define false			0
#define EOS			'\0'
#define quotationMark	'"'
#define blankString		" "
#define BLANK			' '
#define tokenFileName	"token.out"
#define ischar(x)		(isalpha(x) || isdigit(x))
#define allocateMemory(x) (struct x *)getmem(sizeof(struct x))

// token definitions

#define t_keyword		0
#define t_identifier	1
#define t_real			2
#define t_integer		3
#define t_string		4
#define t_special		5
#define t_expression	6

// keyword constants

#define k_main			0
#define k_clrscr		1
#define k_nputs		2
#define k_gotoxy		3
#define k_settextstyle	4

// character defines

#define c_leftbracket	'['
#define c_rightbracket	']'
#define c_comma		','
#define c_none			EOS
#define c_leftparen		'('
#define c_rightparen	')'
#define c_eol			'#'
#define c_plus			'+'
#define c_minus		'-'
#define c_equals		'='
#define c_leftbrace		'{'
#define c_rightbrace	'}'

// structures....
struct nameList {
	int value;
	char *name;
	struct nameList *next;
};

struct symbolTableEntrystruct {
	char symbolName;
	union {
		int ival;
		double dval;
		char *sval;
		char cval;
	};
	struct symbolTableEntrystruct *nextSymbol;
};

struct programNode {
	int statementType;
	int x, y;
	char *text;
	struct programNode *next;
};

// varables

declare int ErrorCount;

// functions used by all modules

void error(char *errorstr);
char *getmem(int size);
char *allocateString(char *s);

#endif